/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2020 Realtek Technologies Co., Ltd
 */

#include "../r8125_ethdev.h"
#include "../r8125_hw.h"
#include "../r8125_phy.h"
#include "rtl8125b_mcu.h"

void hw_init_rxcfg_8125b(struct rtl_hw *hw);
//for RTL8125B, CFG_METHOD_4,5

void hw_init_rxcfg_8125b(struct rtl_hw *hw)
{
        RTL_W32(hw, RxConfig, Rx_Single_fetch_V2 | (RX_DMA_BURST << RxCfgDMAShift) | RxEarly_off_V2);
}

static void hw_ephy_config_8125b(struct rtl_hw *hw)
{
        switch (hw->mcfg) {
        case CFG_METHOD_4:
                rtl8125_ephy_write(hw, 0x06, 0x001F);
                rtl8125_ephy_write(hw, 0x0A, 0xB66B);
                rtl8125_ephy_write(hw, 0x01, 0xA852);
                rtl8125_ephy_write(hw, 0x24, 0x0008);
                rtl8125_ephy_write(hw, 0x2F, 0x6052);
                rtl8125_ephy_write(hw, 0x0D, 0xF716);
                rtl8125_ephy_write(hw, 0x20, 0xD477);
                rtl8125_ephy_write(hw, 0x21, 0x4477);
                rtl8125_ephy_write(hw, 0x22, 0x0013);
                rtl8125_ephy_write(hw, 0x23, 0xBB66);
                rtl8125_ephy_write(hw, 0x0B, 0xA909);
                rtl8125_ephy_write(hw, 0x29, 0xFF04);
                rtl8125_ephy_write(hw, 0x1B, 0x1EA0);

                rtl8125_ephy_write(hw, 0x46, 0x001F);
                rtl8125_ephy_write(hw, 0x4A, 0xB66B);
                rtl8125_ephy_write(hw, 0x41, 0xA84A);
                rtl8125_ephy_write(hw, 0x64, 0x000C);
                rtl8125_ephy_write(hw, 0x6F, 0x604A);
                rtl8125_ephy_write(hw, 0x4D, 0xF716);
                rtl8125_ephy_write(hw, 0x60, 0xD477);
                rtl8125_ephy_write(hw, 0x61, 0x4477);
                rtl8125_ephy_write(hw, 0x62, 0x0013);
                rtl8125_ephy_write(hw, 0x63, 0xBB66);
                rtl8125_ephy_write(hw, 0x4B, 0xA909);
                rtl8125_ephy_write(hw, 0x69, 0xFF04);
                rtl8125_ephy_write(hw, 0x5B, 0x1EA0);
                break;
        case CFG_METHOD_5:
                rtl8125_ephy_write(hw, 0x0B, 0xA908);
                rtl8125_ephy_write(hw, 0x1E, 0x20EB);
                rtl8125_ephy_write(hw, 0x22, 0x0023);
                rtl8125_ephy_write(hw, 0x02, 0x60C2);
                rtl8125_ephy_write(hw, 0x29, 0xFF00);

                rtl8125_ephy_write(hw, 0x4B, 0xA908);
                rtl8125_ephy_write(hw, 0x5E, 0x28EB);
                rtl8125_ephy_write(hw, 0x62, 0x0023);
                rtl8125_ephy_write(hw, 0x42, 0x60C2);
                rtl8125_ephy_write(hw, 0x69, 0xFF00);
                break;
        }
}

static void hw_phy_config_cfg4(struct rtl_hw *hw)
{
        SetEthPhyOcpBit(hw, 0xA442, BIT_11);


        SetEthPhyOcpBit(hw, 0xBC08, (BIT_3 | BIT_2));


        if (HW_HAS_WRITE_PHY_MCU_RAM_CODE(hw)) {
                mdio_direct_write_phy_ocp(hw, 0xA436, 0x8FFF);
                ClearAndSetEthPhyOcpBit(hw,
                                        0xA438,
                                        0xFF00,
                                        0x0400
                                       );
        }
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8560);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x19CC);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8562);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x19CC);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8564);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x19CC);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8566);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x147D);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8568);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x147D);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x856A);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x147D);
        if (HW_HAS_WRITE_PHY_MCU_RAM_CODE(hw)) {
                mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8FFE);
                mdio_direct_write_phy_ocp(hw, 0xB87E, 0x0907);
        }
        ClearAndSetEthPhyOcpBit(hw,
                                0xACDA,
                                0xFF00,
                                0xFF00
                               );
        ClearAndSetEthPhyOcpBit(hw,
                                0xACDE,
                                0xF000,
                                0xF000
                               );
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x80D6);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x2801);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x80F2);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x2801);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x80F4);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x6077);
        mdio_direct_write_phy_ocp(hw, 0xB506, 0x01E7);
        mdio_direct_write_phy_ocp(hw, 0xAC8C, 0x0FFC);
        mdio_direct_write_phy_ocp(hw, 0xAC46, 0xB7B4);
        mdio_direct_write_phy_ocp(hw, 0xAC50, 0x0FBC);
        mdio_direct_write_phy_ocp(hw, 0xAC3C, 0x9240);
        mdio_direct_write_phy_ocp(hw, 0xAC4E, 0x0DB4);
        mdio_direct_write_phy_ocp(hw, 0xACC6, 0x0707);
        mdio_direct_write_phy_ocp(hw, 0xACC8, 0xA0D3);
        mdio_direct_write_phy_ocp(hw, 0xAD08, 0x0007);

        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8013);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x0700);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8FB9);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x2801);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8FBA);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x0100);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8FBC);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x1900);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8FBE);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0xE100);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8FC0);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x0800);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8FC2);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0xE500);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8FC4);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x0F00);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8FC6);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0xF100);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8FC8);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x0400);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8FCa);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0xF300);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8FCc);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0xFD00);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8FCe);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0xFF00);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8FD0);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0xFB00);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8FD2);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x0100);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8FD4);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0xF400);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8FD6);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0xFF00);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8FD8);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0xF600);


        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x813D);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x390E);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x814F);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x790E);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x80B0);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x0F31);
        SetEthPhyOcpBit(hw, 0xBF4C, BIT_1);
        SetEthPhyOcpBit(hw, 0xBCCA, (BIT_9 | BIT_8));
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8141);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x320E);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8153);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x720E);
        ClearEthPhyOcpBit(hw, 0xA432, BIT_6);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8529);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x050E);

        mdio_direct_write_phy_ocp(hw, 0xA436, 0x816C);
        mdio_direct_write_phy_ocp(hw, 0xA438, 0xC4A0);
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x8170);
        mdio_direct_write_phy_ocp(hw, 0xA438, 0xC4A0);
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x8174);
        mdio_direct_write_phy_ocp(hw, 0xA438, 0x04A0);
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x8178);
        mdio_direct_write_phy_ocp(hw, 0xA438, 0x04A0);
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x817C);
        mdio_direct_write_phy_ocp(hw, 0xA438, 0x0719);
        if (HW_HAS_WRITE_PHY_MCU_RAM_CODE(hw)) {
                mdio_direct_write_phy_ocp(hw, 0xA436, 0x8FF4);
                mdio_direct_write_phy_ocp(hw, 0xA438, 0x0400);
                mdio_direct_write_phy_ocp(hw, 0xA436, 0x8FF1);
                mdio_direct_write_phy_ocp(hw, 0xA438, 0x0404);
        }
        mdio_direct_write_phy_ocp(hw, 0xBF4A, 0x001B);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8033);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x7C13);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8037);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x7C13);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x803B);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0xFC32);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x803F);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x7C13);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8043);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x7C13);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8047);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x7C13);


        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8145);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x370E);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8157);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x770E);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8169);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x0D0A);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x817B);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x1D0A);


        mdio_direct_write_phy_ocp(hw, 0xA436, 0x8217);
        ClearAndSetEthPhyOcpBit(hw,
                                0xA438,
                                0xFF00,
                                0x5000
                               );
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x821A);
        ClearAndSetEthPhyOcpBit(hw,
                                0xA438,
                                0xFF00,
                                0x5000
                               );

        mdio_direct_write_phy_ocp(hw, 0xA436, 0x80DA);
        mdio_direct_write_phy_ocp(hw, 0xA438, 0x0403);
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x80DC);
        ClearAndSetEthPhyOcpBit(hw,
                                0xA438,
                                0xFF00,
                                0x1000
                               );
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x80B3);
        mdio_direct_write_phy_ocp(hw, 0xA438, 0x0384);
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x80B7);
        mdio_direct_write_phy_ocp(hw, 0xA438, 0x2007);
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x80BA);
        ClearAndSetEthPhyOcpBit(hw,
                                0xA438,
                                0xFF00,
                                0x6C00
                               );
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x80B5);
        mdio_direct_write_phy_ocp(hw, 0xA438, 0xF009);
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x80BD);
        ClearAndSetEthPhyOcpBit(hw,
                                0xA438,
                                0xFF00,
                                0x9F00
                               );

        mdio_direct_write_phy_ocp(hw, 0xA436, 0x80C7);
        mdio_direct_write_phy_ocp(hw, 0xA438, 0xf083);
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x80DD);
        mdio_direct_write_phy_ocp(hw, 0xA438, 0x03f0);
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x80DF);
        ClearAndSetEthPhyOcpBit(hw,
                                0xA438,
                                0xFF00,
                                0x1000
                               );
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x80CB);
        mdio_direct_write_phy_ocp(hw, 0xA438, 0x2007);
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x80CE);
        ClearAndSetEthPhyOcpBit(hw,
                                0xA438,
                                0xFF00,
                                0x6C00
                               );
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x80C9);
        mdio_direct_write_phy_ocp(hw, 0xA438, 0x8009);
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x80D1);
        ClearAndSetEthPhyOcpBit(hw,
                                0xA438,
                                0xFF00,
                                0x8000
                               );

        mdio_direct_write_phy_ocp(hw, 0xA436, 0x80A3);
        mdio_direct_write_phy_ocp(hw, 0xA438, 0x200A);
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x80A5);
        mdio_direct_write_phy_ocp(hw, 0xA438, 0xF0AD);
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x809F);
        mdio_direct_write_phy_ocp(hw, 0xA438, 0x6073);
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x80A1);
        mdio_direct_write_phy_ocp(hw, 0xA438, 0x000B);
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x80A9);
        ClearAndSetEthPhyOcpBit(hw,
                                0xA438,
                                0xFF00,
                                0xC000
                               );

        rtl8125_set_phy_mcu_patch_request(hw);

        ClearEthPhyOcpBit(hw, 0xB896, BIT_0);
        ClearEthPhyOcpBit(hw, 0xB892, 0xFF00);

        mdio_direct_write_phy_ocp(hw, 0xB88E, 0xC23E);
        mdio_direct_write_phy_ocp(hw, 0xB890, 0x0000);
        mdio_direct_write_phy_ocp(hw, 0xB88E, 0xC240);
        mdio_direct_write_phy_ocp(hw, 0xB890, 0x0103);
        mdio_direct_write_phy_ocp(hw, 0xB88E, 0xC242);
        mdio_direct_write_phy_ocp(hw, 0xB890, 0x0507);
        mdio_direct_write_phy_ocp(hw, 0xB88E, 0xC244);
        mdio_direct_write_phy_ocp(hw, 0xB890, 0x090B);
        mdio_direct_write_phy_ocp(hw, 0xB88E, 0xC246);
        mdio_direct_write_phy_ocp(hw, 0xB890, 0x0C0E);
        mdio_direct_write_phy_ocp(hw, 0xB88E, 0xC248);
        mdio_direct_write_phy_ocp(hw, 0xB890, 0x1012);
        mdio_direct_write_phy_ocp(hw, 0xB88E, 0xC24A);
        mdio_direct_write_phy_ocp(hw, 0xB890, 0x1416);

        SetEthPhyOcpBit(hw, 0xB896, BIT_0);

        rtl8125_clear_phy_mcu_patch_request(hw);


        SetEthPhyOcpBit(hw, 0xA86A, BIT_0);
        SetEthPhyOcpBit(hw, 0xA6F0, BIT_0);


        mdio_direct_write_phy_ocp(hw, 0xBFA0, 0xD70D);
        mdio_direct_write_phy_ocp(hw, 0xBFA2, 0x4100);
        mdio_direct_write_phy_ocp(hw, 0xBFA4, 0xE868);
        mdio_direct_write_phy_ocp(hw, 0xBFA6, 0xDC59);
        mdio_direct_write_phy_ocp(hw, 0xB54C, 0x3C18);
        ClearEthPhyOcpBit(hw, 0xBFA4, BIT_5);
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x817D);
        SetEthPhyOcpBit(hw, 0xA438, BIT_12);

        /*
                if (aspm) {
                        if (HW_HAS_WRITE_PHY_MCU_RAM_CODE(hw)) {
                                rtl8125_enable_phy_aldps(hw);
                        }
                }*/
}

static void hw_phy_config_cfg5(struct rtl_hw *hw)
{
        SetEthPhyOcpBit(hw, 0xA442, BIT_11);


        ClearAndSetEthPhyOcpBit(hw,
                                0xAC46,
                                0x00F0,
                                0x0090
                               );
        ClearAndSetEthPhyOcpBit(hw,
                                0xAD30,
                                0x0003,
                                0x0001
                               );

        RTL_W16(hw, EEE_TXIDLE_TIMER_8125, hw->mtu + ETH_HLEN + 0x20);

        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x80F5);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x760E);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8107);
        mdio_direct_write_phy_ocp(hw, 0xB87E, 0x360E);
        mdio_direct_write_phy_ocp(hw, 0xB87C, 0x8551);
        ClearAndSetEthPhyOcpBit(hw,
                                0xB87E,
                                BIT_15 | BIT_14 | BIT_13 | BIT_12 | BIT_11 | BIT_10 | BIT_9 | BIT_8,
                                BIT_11
                               );

        ClearAndSetEthPhyOcpBit(hw,
                                0xbf00,
                                0xE000,
                                0xA000
                               );
        ClearAndSetEthPhyOcpBit(hw,
                                0xbf46,
                                0x0F00,
                                0x0300
                               );
        mdio_direct_write_phy_ocp(hw, 0xa436, 0x8044);
        mdio_direct_write_phy_ocp(hw, 0xa438, 0x2417);
        mdio_direct_write_phy_ocp(hw, 0xa436, 0x804A);
        mdio_direct_write_phy_ocp(hw, 0xa438, 0x2417);
        mdio_direct_write_phy_ocp(hw, 0xa436, 0x8050);
        mdio_direct_write_phy_ocp(hw, 0xa438, 0x2417);
        mdio_direct_write_phy_ocp(hw, 0xa436, 0x8056);
        mdio_direct_write_phy_ocp(hw, 0xa438, 0x2417);
        mdio_direct_write_phy_ocp(hw, 0xa436, 0x805C);
        mdio_direct_write_phy_ocp(hw, 0xa438, 0x2417);
        mdio_direct_write_phy_ocp(hw, 0xa436, 0x8062);
        mdio_direct_write_phy_ocp(hw, 0xa438, 0x2417);
        mdio_direct_write_phy_ocp(hw, 0xa436, 0x8068);
        mdio_direct_write_phy_ocp(hw, 0xa438, 0x2417);
        mdio_direct_write_phy_ocp(hw, 0xa436, 0x806E);
        mdio_direct_write_phy_ocp(hw, 0xa438, 0x2417);
        mdio_direct_write_phy_ocp(hw, 0xa436, 0x8074);
        mdio_direct_write_phy_ocp(hw, 0xa438, 0x2417);
        mdio_direct_write_phy_ocp(hw, 0xa436, 0x807A);
        mdio_direct_write_phy_ocp(hw, 0xa438, 0x2417);


        SetEthPhyOcpBit(hw, 0xA4CA, BIT_6);


        ClearAndSetEthPhyOcpBit(hw,
                                0xBF84,
                                BIT_15 | BIT_14 | BIT_13,
                                BIT_15 | BIT_13
                               );


        mdio_direct_write_phy_ocp(hw, 0xA436, 0x8170);
        ClearAndSetEthPhyOcpBit(hw,
                                0xA438,
                                BIT_13 | BIT_10 | BIT_9 | BIT_8,
                                BIT_15 | BIT_14 | BIT_12 | BIT_11
                               );

        /*
        mdio_direct_write_phy_ocp(hw, 0xBFA0, 0xD70D);
        mdio_direct_write_phy_ocp(hw, 0xBFA2, 0x4100);
        mdio_direct_write_phy_ocp(hw, 0xBFA4, 0xE868);
        mdio_direct_write_phy_ocp(hw, 0xBFA6, 0xDC59);
        mdio_direct_write_phy_ocp(hw, 0xB54C, 0x3C18);
        ClearEthPhyOcpBit(hw, 0xBFA4, BIT_5);
        mdio_direct_write_phy_ocp(hw, 0xA436, 0x817D);
        SetEthPhyOcpBit(hw, 0xA438, BIT_12);
        */

        /*
                if (aspm) {
                        if (HW_HAS_WRITE_PHY_MCU_RAM_CODE(hw)) {
                                rtl8125_enable_phy_aldps(hw);
                        }
                }*/
}

static void hw_phy_config_8125b(struct rtl_hw *hw)
{
        if (hw->mcfg == CFG_METHOD_4) {

                hw_phy_config_cfg4(hw);

        } else if (hw->mcfg == CFG_METHOD_5) {

                hw_phy_config_cfg5(hw);

        }
}

static void hw_mac_mcu_config_8125b(struct rtl_hw *hw)
{
        switch (hw->mcfg) {
        case CFG_METHOD_4:
                rtl8125_set_mac_mcu_8125b_1(hw);
                break;
        case CFG_METHOD_5:
                rtl8125_set_mac_mcu_8125b_2(hw);
                break;
        }
}

static void hw_phy_mcu_config_8125b(struct rtl_hw *hw)
{
        switch (hw->mcfg) {
        case CFG_METHOD_4:
                rtl8125_set_phy_mcu_8125b_1(hw);
                break;
        case CFG_METHOD_5:
                rtl8125_set_phy_mcu_8125b_2(hw);
                break;
        }
}

const struct rtl_hw_ops rtl8125b_ops = {
        //.hw_config = hw_config_8125a,
        .hw_init_rxcfg = hw_init_rxcfg_8125b,
        .hw_ephy_config = hw_ephy_config_8125b,
        .hw_phy_config = hw_phy_config_8125b,
        .hw_mac_mcu_config = hw_mac_mcu_config_8125b,
        .hw_phy_mcu_config = hw_phy_mcu_config_8125b,
};
